/**
 * Copyright 2011 ArcBees Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package com.gwtplatform.samples.hplace.shared;

import com.gwtplatform.dispatch.annotation.GenDispatch;
import com.gwtplatform.dispatch.annotation.In;
import com.gwtplatform.dispatch.annotation.Out;
import com.gwtplatform.dispatch.shared.Action;

import java.util.ArrayList;

/**
 * This classes uses GWTP annotation processors
 * to generate {@link GetProductListAction} and
 * {@link GetProductListResult}.
 *
 * @author Philippe Beaudoin
 */
@GenDispatch(isSecure = false, serviceName = "/" + Action.DEFAULT_SERVICE_NAME + "GetProductList")
public class GetProductList {
  @In(1)
  int flags;

  @Out(1)
  ArrayList<Product> products;
}
